package com.boman.web.core.controller;

import com.alibaba.fastjson.JSONObject;
import com.boman.common.core.utils.obj.ObjectUtils;
import com.boman.domain.Czrk;
import com.boman.domain.CzrkJzdz;
import com.boman.domain.VaccineInfoOperation;
import com.boman.domain.dto.AjaxResult;
import com.boman.web.core.domain.SysRegion;
import com.boman.web.core.mapper.*;
import com.boman.web.core.service.vaccineInfo.IVaccineInfoService;
import com.boman.web.core.service.vaccineInfo.impl.VaccineInfoServiceImpl;
import com.boman.web.core.utils.IdUtils;
import com.google.common.base.Strings;
import org.apache.commons.lang3.StringUtils;
import org.checkerframework.checker.units.qual.A;
import org.checkerframework.checker.units.qual.C;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.List;
import java.util.Objects;

/**
 * @author shiqian
 * @date 2021年09月08日 10:40
 **/
@RestController
@RequestMapping("/test")
public class TestController {
    @Resource
    private VaccineInfoMapper mapper;

    @Autowired
    private SysRegionMapper sysRegionMapper;

    @Autowired
    private CzrkMapper czrkMapper;

    @Autowired
    private CzrkJzdzMapper czrkJzdzMapper;

    @GetMapping("/handleData")
    public AjaxResult handleData() {
        List<VaccineInfoOperation> list = mapper.handleData();
        for (VaccineInfoOperation vaccineInfoOperation : list) {
            if (Objects.isNull(vaccineInfoOperation.getAge()) && ObjectUtils.isEmpty(vaccineInfoOperation.getBirthday())) {
                continue;
            }

            mapper.updateAgeBirthday(vaccineInfoOperation);
        }

        return new AjaxResult();
    }

    @GetMapping("/setHouseType")
    public AjaxResult setHouseType() {
        List<JSONObject> list = mapper.getHouseType();
        for (JSONObject json : list) {
            String idCard = json.getString("idCard");
            String yhzgx = json.getString("yhzgx");// 与户主关系
            String code = json.getString("code"); // 户号

            String houseType = "", yhzgx1 = "";
            if (StringUtils.isNotEmpty(yhzgx)) {
                yhzgx = yhzgx.trim();
                if ("户主".equals(yhzgx)) {
                    houseType = "是";
                    yhzgx1 = "户主";
                } else {
                    houseType = "否";
                    yhzgx1 = yhzgx;
                }
            }

            mapper.setHouseType(idCard, code, yhzgx1, houseType);
        }

        return new AjaxResult();
    }

    /**
     * 处理常驻人口数据
     *
     * @return
     */
    @PostMapping("/setCzrk")
    public AjaxResult setCzrk() {
        //587731
        for (int i = 0; i < 59; i++) {
            int startPage = i * 10000;
            int endPage = 10000;
            List<VaccineInfoOperation> vaccineInfoOperations = mapper.selectVaccineInfoListByPage(startPage, endPage);
            if (vaccineInfoOperations.size() > 0) {
                for (VaccineInfoOperation vaccineInfoOperation : vaccineInfoOperations) {
                    if (vaccineInfoOperation != null) {
                        Czrk czrk = new Czrk();
                        czrk.setUserName(vaccineInfoOperation.getUserName());
                        czrk.setGender(vaccineInfoOperation.getGender());
                        czrk.setAge(vaccineInfoOperation.getAge());
                        czrk.setBirthday(vaccineInfoOperation.getBirthday());
                        czrk.setDeptId(vaccineInfoOperation.getDeptId());
                        czrk.setIdCard(vaccineInfoOperation.getIdCard());
                        czrk.setPhoneNum(vaccineInfoOperation.getPhoneNum());
                        czrk.setCode(vaccineInfoOperation.getCode());
                        czrk.setHouseType(vaccineInfoOperation.getHouseType());
                        czrk.setRlr(vaccineInfoOperation.getRlr());
                        czrk.setYhzgx(vaccineInfoOperation.getYhzgx());
                        czrk.setWorkUnit(vaccineInfoOperation.getWorkUnit());
                        //户籍地镇
                        String villageTowns = vaccineInfoOperation.getVillageTowns();
                        if (StringUtils.isNotBlank(villageTowns)) {
                            czrk.setIsRl("是");
                            List<SysRegion> sysRegions = sysRegionMapper.selectSysRegionByName(villageTowns);
                            if (sysRegions.size() > 0) {
                                for (SysRegion sysRegion : sysRegions) {
                                    if (sysRegion != null) {
                                        Long pid = sysRegion.getPid();
                                        if (pid != null) {
                                            if ("340882000000".equals(pid.toString())) {
                                                czrk.setVillageTownsId(sysRegion.getAreaId());
                                                czrk.setVillageTowns(villageTowns);
                                            }
                                        }

                                    }
                                }
                            }
                        }
                        String villagerGroup = vaccineInfoOperation.getVillagerGroup();
                        if (StringUtils.isNotBlank(villagerGroup)) {
                            List<SysRegion> sysRegions = sysRegionMapper.selectSysRegionByName(villagerGroup);
                            if (sysRegions.size() > 1) {
                                for (SysRegion sysRegion : sysRegions) {
                                    if (sysRegion != null) {
                                        Long villageTownsId = czrk.getVillageTownsId();
                                        if (villageTownsId != null && villageTownsId.equals(sysRegion.getPid())) {
                                            czrk.setVillageId(sysRegion.getAreaId());
                                            czrk.setVillageTowns(villagerGroup);
                                        }
                                    }
                                }
                            } else if (sysRegions.size() == 1) {
                                SysRegion sysRegion = sysRegions.get(0);
                                if (sysRegion != null) {
                                    czrk.setVillageId(sysRegion.getAreaId());
                                    czrk.setVillageTowns(villagerGroup);
                                }
                            }
                        }
                        czrk.setIsDel(vaccineInfoOperation.getIsDel());
                        czrk.setDeleteReason(vaccineInfoOperation.getDeleteReason());
                        czrk.setNowIn(vaccineInfoOperation.getDomicile());
                        czrk.setRemark(vaccineInfoOperation.getRemark());
                        czrk.setCreateBy("admin");
                        czrkMapper.insertCzrk(czrk);

                        CzrkJzdz czrkJzdz = new CzrkJzdz();
                        czrkJzdz.setCzrkId(czrk.getId());
                        czrkJzdz.setIdCard(vaccineInfoOperation.getIdCard());
                        czrkJzdz.setUserName(vaccineInfoOperation.getUserName());
                        czrkJzdz.setDeptId(vaccineInfoOperation.getDeptId());
                        //现在居住地省
                        String province = vaccineInfoOperation.getProvince();
                        if (StringUtils.isNotBlank(province)) {
                            List<SysRegion> sysRegions = sysRegionMapper.selectSysRegionByName(province);
                            if (sysRegions.size() > 0) {
                                SysRegion sysRegion = sysRegions.get(0);
                                if (sysRegion != null) {
                                    czrkJzdz.setProvinceId(sysRegion.getAreaId());
                                    czrkJzdz.setProvince(province);
                                }

                            }
                        }
                        //现在居住地市
                        String city = vaccineInfoOperation.getCity();
                        if (StringUtils.isNotBlank(city)) {
                            List<SysRegion> sysRegions = sysRegionMapper.selectSysRegionByName(city);
                            if (sysRegions.size() > 0) {
                                SysRegion sysRegion = sysRegions.get(0);
                                if (sysRegion != null) {
                                    czrkJzdz.setCityId(sysRegion.getAreaId());
                                    czrkJzdz.setCity(city);
                                }
                            }
                        }

                        //现在居住地区
                        String region = vaccineInfoOperation.getRegion();
                        if (StringUtils.isNotBlank(region)) {
                            List<SysRegion> sysRegions = sysRegionMapper.selectSysRegionByName(region);
                            //如果有多个区,名字相同的,切没有市的信息,则不赋值
                            if (sysRegions.size() > 1) {
                                for (SysRegion sysRegion : sysRegions) {
                                    if (sysRegion != null) {
                                        Long cityId = czrkJzdz.getCityId();
                                        if (cityId != null) {
                                            if (cityId.equals(sysRegion.getPid())) {
                                                czrkJzdz.setRegionId(sysRegion.getAreaId());
                                                czrkJzdz.setRegion(region);
                                            }
                                        }
                                    }
                                }
                            } else if (sysRegions.size() == 1) {
                                SysRegion sysRegion = sysRegions.get(0);
                                if (sysRegion != null) {
                                    czrkJzdz.setRegionId(sysRegion.getAreaId());
                                    czrkJzdz.setRegion(region);
                                }
                            }
                        }

                        //居住地的镇
                        String residenceTown = vaccineInfoOperation.getResidenceTown();
                        if (StringUtils.isNotBlank(residenceTown)) {
                            List<SysRegion> sysRegions = sysRegionMapper.selectSysRegionByName(residenceTown);
                            if (sysRegions.size() > 1) {
                                for (SysRegion sysRegion : sysRegions) {
                                    if (sysRegion != null) {
                                        Long regionId = czrkJzdz.getRegionId();
                                        if (regionId != null && regionId.equals(sysRegion.getPid())) {
                                            czrkJzdz.setTownId(sysRegion.getAreaId());
                                            czrkJzdz.setTown(residenceTown);
                                        }
                                    }
                                }
                            } else if (sysRegions.size() == 1) {
                                SysRegion sysRegion = sysRegions.get(0);
                                if (sysRegion != null) {
                                    czrkJzdz.setTownId(sysRegion.getAreaId());
                                    czrkJzdz.setTown(residenceTown);
                                }
                            }
                        }

                        //居住地的村
                        String residenceVillage = vaccineInfoOperation.getResidenceVillage();
                        if (StringUtils.isNotBlank(residenceVillage)) {
                            List<SysRegion> sysRegions = sysRegionMapper.selectSysRegionByName(residenceVillage);
                            if (sysRegions.size() > 1) {
                                for (SysRegion sysRegion : sysRegions) {
                                    if (sysRegion != null) {
                                        Long townId = czrkJzdz.getTownId();
                                        if (townId != null && townId.equals(sysRegion.getPid())) {
                                            czrkJzdz.setVillageId(sysRegion.getAreaId());
                                            czrkJzdz.setVillage(residenceVillage);
                                        }
                                    }
                                }
                            } else if (sysRegions.size() == 1) {
                                SysRegion sysRegion = sysRegions.get(0);
                                if (sysRegion != null) {
                                    czrkJzdz.setVillageId(sysRegions.get(0).getAreaId());
                                    czrkJzdz.setVillage(residenceVillage);
                                }
                            }
                        }
                        czrkJzdz.setNowIn(vaccineInfoOperation.getNowIn());
                        czrkJzdz.setCreateBy("admin");
                        czrkJzdzMapper.insertCzrkJzdz(czrkJzdz);
                    }
                }
            }
            System.out.println("处理完成" + startPage + "数据");
        }
        return AjaxResult.success("全部完成");
    }
}
