package com.boman.web.core.mapper;

import com.boman.domain.Czrk;
import com.boman.domain.VaccineInfoOperation;
import org.apache.ibatis.annotations.Param;
import org.checkerframework.checker.units.qual.C;

import java.util.List;


/**
 * 常住人口Mapper接口
 *
 * @author ruoyi
 * @date 2022-01-14
 */
public interface CzrkMapper {
    /**
     * 查询常住人口
     *
     * @param id 常住人口主键
     * @return 常住人口
     */
    Czrk selectCzrkById(Long id);
    int countIdCard(String idCard);

    /**
     * 查询常住人口列表
     *
     * @param czrk 常住人口
     * @return 常住人口集合
     */
    List<Czrk> selectCzrkList(Czrk czrk);

    /**
     * 新增常住人口
     *
     * @param czrk 常住人口
     * @return 结果
     */
    int insertCzrk(Czrk czrk);

    /**
     * 修改常住人口
     *
     * @param czrk 常住人口
     * @return 结果
     */
    int updateCzrk(Czrk czrk);

    /**
     * 删除常住人口
     *
     * @param id 常住人口主键
     * @return 结果
     */
    int deleteCzrkById(Long id);

    int reduction(String id);

    /**
     * 批量删除常住人口
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
//    int deleteCzrk(Long[] ids);
    int deleteCzrk(Czrk czrk);

    List<Czrk> listByRlry(Czrk czrk);
    List<Czrk> listByRlryRel(Czrk czrk);

    List<Czrk> listByXz(Czrk czrk);
    List<Czrk> listByJs(Czrk czrk);
//    int countByJs(Czrk czrk);
//    int countByXz(Czrk czrk);
    int countCzrk(@Param("type") int type, @Param("areaId") Long areaId);


    List<Czrk> listByCode(String code);


    int stsByYrl(@Param("type") int type, @Param("areaId") Long areaId, @Param("userName") String userName);
    int stsByWrl(@Param("type") int type, @Param("areaId") Long areaId, @Param("userName") String userName);

    List<Czrk> listIsRl(@Param("type") int type, @Param("areaId") Long areaId, @Param("userName") String userName);

//    int stsByWrl(@Param("deptIdList") List<Long> deptIdList, @Param("userName") String userName);


    /**
     *根据身份证号查询用户信息
     * @param czrk
     * @return
     */
   Czrk findHjInfo(Czrk czrk);
    List<Czrk> stsByAppletCz(@Param("type") int type, @Param("areaId") Long areaId, @Param("userName") String userName);

    List<Czrk> listByCzXz(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("type") int type, @Param("areaId") Long areaId);
    List<Czrk> listByCzJs(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("type") int type, @Param("areaId") Long areaId);

    int countByCzXz(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("type") int type, @Param("areaId") Long areaId);
    int countByCzJs(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("type") int type, @Param("areaId") Long areaId);

    List<Czrk>  countByHjXz(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("type") int type, @Param("areaId") Long areaId);

    List<Czrk>  countByHjJs(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("type") int type, @Param("areaId") Long areaId);

    List<Czrk> countHj(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("type") int type, @Param("areaId") Long areaId);
}
