package com.boman.web.core.service.czrk;

import com.boman.domain.CzrkJzdz;
import com.boman.web.core.mapper.CzrkJzdzMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Collections;
import java.util.List;

import static com.boman.common.core.utils.obj.ObjectUtils.isEmpty;

/**
 * 常住人口对应的居住地址Service业务层处理
 *
 * @author ruoyi
 * @date 2022-01-14
 */
@Service
public class CzrkJzdzServiceImpl implements ICzrkJzdzService {

    @Autowired
    private CzrkJzdzMapper czrkJzdzMapper;

    /**
     * 查询常住人口对应的居住地址
     *
     * @param id 常住人口对应的居住地址主键
     * @return 常住人口对应的居住地址
     */
    @Override
    public CzrkJzdz selectCzrkJzdzById(Long id) {
        return czrkJzdzMapper.selectCzrkJzdzById(id);
    }

    /**
     * 查询常住人口对应的居住地址列表
     *
     * @param czrkJzdz 常住人口对应的居住地址
     * @return 常住人口对应的居住地址
     */
    @Override
    public List<CzrkJzdz> selectCzrkJzdzList(CzrkJzdz czrkJzdz) {
        return czrkJzdzMapper.selectCzrkJzdzList(czrkJzdz);
    }

    /**
     * 新增常住人口对应的居住地址
     *
     * @param czrkJzdz 常住人口对应的居住地址
     * @return 结果
     */
    @Override
    public int insertCzrkJzdz(CzrkJzdz czrkJzdz) {
        return czrkJzdzMapper.insertCzrkJzdz(czrkJzdz);
    }

    /**
     * 修改常住人口对应的居住地址
     *
     * @param czrkJzdz 常住人口对应的居住地址
     * @return 结果
     */
    @Override
    public int updateCzrkJzdz(CzrkJzdz czrkJzdz) {
        return czrkJzdzMapper.updateCzrkJzdz(czrkJzdz);
    }

    /**
     * 批量删除常住人口对应的居住地址
     *
     * @param ids 需要删除的常住人口对应的居住地址主键
     * @return 结果
     */
    @Override
    public int deleteCzrkJzdzByIds(Long[] ids) {
        return czrkJzdzMapper.deleteCzrkJzdzByIds(ids);
    }

    /**
     * 删除常住人口对应的居住地址信息
     *
     * @param id 常住人口对应的居住地址主键
     * @return 结果
     */
    @Override
    public int deleteCzrkJzdzById(Long id) {
        return czrkJzdzMapper.deleteCzrkJzdzById(id);
    }

    @Override
    public int deleteByCzrkId(Long czrkId) {
        return czrkJzdzMapper.deleteByCzrkId(czrkId);
    }

    @Override
    public List<CzrkJzdz> listByIdCard(List<String> idCardList) {
        if (isEmpty(idCardList)) {
            return Collections.emptyList();
        }

        return czrkJzdzMapper.listByIdCard(idCardList);
    }

    @Override
    public List<Long> listCzrkIdByTypeAreaIdUserName(int type, Long areaId, String userName) {
        return czrkJzdzMapper.listCzrkIdByTypeAreaIdUserName(type, areaId, userName);
    }

    @Override
    public int updateByIdCard(CzrkJzdz czrkJzdz) {
        return czrkJzdzMapper.updateByIdCard(czrkJzdz);
    }
}
