package com.boman.web.core.service.czrk;


import com.boman.domain.CzrkJzdz;

import java.util.List;

/**
 * 常住人口对应的居住地址Service接口
 *
 * @author ruoyi
 * @date 2022-01-14
 */
public interface ICzrkJzdzService {
    /**
     * 查询常住人口对应的居住地址
     *
     * @param id 常住人口对应的居住地址主键
     * @return 常住人口对应的居住地址
     */
    CzrkJzdz selectCzrkJzdzById(Long id);

    /**
     * 查询常住人口对应的居住地址列表
     *
     * @param czrkJzdz 常住人口对应的居住地址
     * @return 常住人口对应的居住地址集合
     */
    List<CzrkJzdz> selectCzrkJzdzList(CzrkJzdz czrkJzdz);

    /**
     * 新增常住人口对应的居住地址
     *
     * @param czrkJzdz 常住人口对应的居住地址
     * @return 结果
     */
    int insertCzrkJzdz(CzrkJzdz czrkJzdz);

    /**
     * 修改常住人口对应的居住地址
     *
     * @param czrkJzdz 常住人口对应的居住地址
     * @return 结果
     */
    int updateCzrkJzdz(CzrkJzdz czrkJzdz);

    /**
     * 批量删除常住人口对应的居住地址
     *
     * @param ids 需要删除的常住人口对应的居住地址主键集合
     * @return 结果
     */
    int deleteCzrkJzdzByIds(Long[] ids);

    /**
     * 删除常住人口对应的居住地址信息
     *
     * @param id 常住人口对应的居住地址主键
     * @return 结果
     */
    int deleteCzrkJzdzById(Long id);
    int deleteByCzrkId(Long czrkId);

    List<CzrkJzdz> listByIdCard(List<String> idCardList);

    List<Long> listCzrkIdByTypeAreaIdUserName(int type, Long areaId, String userName);

    int updateByIdCard(CzrkJzdz czrkJzdz);
}
