package com.boman.web.core.service.czrk;

import com.alibaba.fastjson.JSONObject;
import com.boman.domain.Czrk;
import com.boman.domain.dto.AjaxResult;

import java.util.List;

/**
 * 常住人口Service接口
 *
 * @author ruoyi
 * @date 2022-01-14
 */
public interface ICzrkService {


    List<Czrk> listByRlry(Czrk czrk);

    List<Czrk> listByXz(Czrk czrk);
    List<Czrk> listByJs(Czrk czrk);
    /**
     * 查询常住人口
     *
     * @param id 常住人口主键
     * @return 常住人口
     */
    Czrk selectCzrkById(Long id);

    /**
     * 查询常住人口列表
     *
     * @param czrk 常住人口
     * @return 常住人口集合
     */
    List<Czrk> selectCzrkList(Czrk czrk);

    /**
     * 新增常住人口
     *
     * @param czrk 常住人口
     * @return 结果
     */
    int insertCzrk(Czrk czrk);

    /**
     * 修改常住人口
     *
     * @param czrk 常住人口
     * @return 结果
     */
    int updateCzrk(Czrk czrk);

    /**
     * 批量删除常住人口
     *
     * @param ids 需要删除的常住人口主键集合
     * @return 结果
     */
//    int deleteCzrkByIds(Long[] ids);

    /**
     * 删除常住人口信息
     *
     * @param id 常住人口主键
     * @return 结果
     */
    int deleteCzrkById(Long id);

    int deleteCzrk(Czrk czrk);
    int reduction(String id);
    List<Czrk> family(String code);

    Czrk getById(Long id);

    AjaxResult addRlry(Czrk czrk);
    AjaxResult editRlry(Czrk czrk);

    JSONObject stsByApplet(Long provinceId, Long cityId, Long regionId, Long townId, Long villageId, String userName, String queryType);
    JSONObject stsByCzrk();
    JSONObject stsByCzrkHomePage();

    /**
     * 根据身份证号查询用户信息
     * @param czrk
     * @return
     */
    Czrk findHjInfo(Czrk czrk);

    JSONObject hjczLine();
}
